#include <bits/stdc++.h>
using namespace std;

vector<int> funkc(int a){
	vector<int> b;
	for (int i=1;i*i<=a;i++){
		
		if (a%i==0){
			b.push_back(i);
			if (i*i!=a) b.push_back(a/i);
		}
		
	}
	return b;
	
}
int main(int argc, char** argv) {
	
	int n,k;
	cin>>n>>k;
	vector<int> a(k);
	for (int i=0;i<k;i++){
		
		cin>>a[i];
	}
	
	for (int i =0 ;i<k;i++){
		vector<int> delioci = funkc(a[i]);
		int tr = delioci[0];
		
//		for (int i =0;i<delioci.size();i++) cout<<delioci[i]<<" ";
		
		for (int i=1;i<delioci.size();i++){
			tr = tr^delioci[i];
		}
		cout<<tr<<'\n';
	}
	
	
	return 0;
}